Bug 36117 - EDITING Page formatting doesn't support vertical alignment (top/center/bottom) of content (without frame/table workarounds)
Summary: EDITING Page formatting doesn't support vertical alignment (top/center/bottom...
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: high enhancement
Assignee: Not Assigned
QA Contact:
URL:
Whiteboard: interoperability
Keywords:
: 77081 93642 101845 (view as bug list)
Depends on:
Blocks: Page-Dialog Vertical-Text
  Show dependency treegraph
 
Reported: 2011-04-10 09:17 UTC by vermontpoet
Modified: 2017-07-28 17:38 UTC (History)
23 users (show)

See Also:
Crash report or crash signature:


Attachments
document needing vertical centering in .doc and .pdf format (1.53 MB, application/zip)
2015-08-01 05:01 UTC, Justin L
Details
A word document with a vertically centered period (.) . (12.40 KB, application/vnd.openxmlformats-officedocument.wordprocessingml.document)
2015-08-01 12:59 UTC, vermontpoet
Details
A word document with a vertically centered period (.) . (word 97 doc file) (21.50 KB, application/msword)
2015-08-01 13:00 UTC, vermontpoet
Details
zip containing various word2003-authored test scenario documents (27.73 KB, application/zip)
2015-09-11 05:49 UTC, Justin L
Details

Note You need to log in before you can comment on or make changes to this bug.
Description vermontpoet 2011-04-10 09:17:58 UTC
It should *not* be necessary to use Frames to Vertically Center Text on a page. Libre Office's current method (inherited from Open Office) is unwieldy, absurdly inefficient, and incompatible with (to my knowledge) every other modern Word Processor. I can currently boot up Virtualbox, start at instance of XP Pro, choose WordPerfect from the Start Menu, then click on Vertically Center Text with fewer mouse/key strokes than it takes to accomplish the same thing in an *already running* instance of Libre Office. This is ridiculous.

It also means that because LO lacks this very simple and basic functionality, it remains incompatible with Microsoft Office. LO currently fails to convert vertically centered when inheriting a document from MS Office, WordPerfect *or* Textmaker! 

On the other hand, this basic "one click" functionality is available in Textmaker, MS Office and Corel WordPerfect.

I marked the priority as highest and the severity as critical because it's a limitation that would appear easy to remedy and has been requested for several years:

http://www.oooforum.org/forum/viewtopic.phtml?t=58666&highlight=alignment

And recently here:

http://en.libreofficeforum.org/node/498#comment-1459

I hope, now that Libre Office is competent hands, this limitation can be quickly remedied.
Comment 1 Andy Brown 2011-04-10 09:30:52 UTC
Though not something that I have need I see where this would be very important to some users.  OOo bug/feature [1].  This is something that should have been taken care of years ago and I would like to see LibreOffice take care of it as soon as possible.  If not in version 3.4 in one of the bug fixes after that.

[1] http://openoffice.org/bugzilla/show_bug.cgi?id=22614
Comment 2 mdg 2011-04-10 16:31:50 UTC Comment hidden (me-too)
Comment 3 Jan Holesovsky 2011-04-14 14:47:15 UTC
So - setting this to 'Higest' 'Critical' priority does not help ;-)  What would help a lot is getting hands dirty with code - please come to the #libreoffice-dev channel or irc.freenode.net, or to libreoffice@lists.freedesktop.org, and we will gladly help you to find the place where to code.
Comment 4 vermontpoet 2011-04-14 17:19:42 UTC
Thanks Jan. I'm a writer, not a coder. Believe me, if I were able, I would love to contribute code. It's not a sense of entitlement that prevents me, only a lack of ability. I haven't written code since 1983.

However, show some examples of code similar to what you might need, and I'll take a look.
Comment 5 Björn Michaelsen 2011-12-23 12:03:21 UTC Comment hidden (obsolete)
Comment 6 mondane.woodworker 2011-12-25 14:02:08 UTC
Tested this functionality in 3.5.0-beta-2 and the only way I can find to center text vertically on a page is still using frames (setting it to a horizontal and vertical centered position relative to the whole page).

In other words; this bug report still stands.

Steps taken to reproduce:
1) Open LibreOffice
2) Start a new Writer document
3) Type this line:
  "The quick brown fox jumps over the lazy dog"
4) Right click the paragraph and select 'Page...'
5) Go to tab 'Alignment'
6) Select the bullet 'Middle' and press 'Apply'

The result would be a vetically centered paragraph relative to the whole page.

Note: obviously, steps 5 and 6 aren't possible in the current version of LibreOffice Writer.
Comment 7 Paul Hubert 2012-04-26 09:39:36 UTC Comment hidden (me-too)
Comment 8 joe4379 2012-05-01 10:44:44 UTC Comment hidden (me-too)
Comment 9 joe4379 2012-05-01 10:47:08 UTC Comment hidden (me-too)
Comment 10 Patrick Gillespie 2012-05-01 12:33:56 UTC Comment hidden (me-too)
Comment 11 AlbertJB 2012-07-10 22:41:34 UTC Comment hidden (me-too)
Comment 12 Will Maynard 2012-11-18 16:05:18 UTC Comment hidden (me-too)
Comment 13 GM 2012-11-28 21:26:50 UTC Comment hidden (me-too)
Comment 14 vermontpoet 2013-05-27 02:27:54 UTC Comment hidden (abusive)
Comment 15 hollandgh 2013-12-13 04:13:45 UTC Comment hidden (me-too)
Comment 16 tommy27 2014-01-07 00:51:08 UTC
(In reply to comment #0)
> It should *not* be necessary to use Frames to Vertically Center Text on a
> page. Libre Office's current method (inherited from Open Office) is
> unwieldy, absurdly inefficient, and incompatible with (to my knowledge)
> every other modern Word Processor. 
> ....

change version to "inherited from OOo"
Comment 17 Patrick Gillespie 2014-01-07 01:19:49 UTC Comment hidden (no-value)
Comment 18 Aaron D. Campbell 2014-02-10 22:15:24 UTC Comment hidden (me-too)
Comment 19 Patrick Gillespie 2014-02-11 01:44:25 UTC Comment hidden (abusive)
Comment 20 tommy27 2014-02-11 06:41:04 UTC Comment hidden (off-topic)
Comment 21 Patrick Gillespie 2014-02-11 13:06:33 UTC Comment hidden (off-topic)
Comment 22 tommy27 2014-02-11 14:08:47 UTC Comment hidden (off-topic)
Comment 23 Patrick Gillespie 2014-02-11 15:15:45 UTC Comment hidden (off-topic)
Comment 24 tommy27 2014-02-11 18:22:11 UTC Comment hidden (off-topic)
Comment 25 Patrick Gillespie 2014-02-11 18:32:58 UTC Comment hidden (abusive)
Comment 26 James 2014-03-02 19:45:06 UTC Comment hidden (abusive)
Comment 27 Danixu 2014-04-05 16:22:33 UTC Comment hidden (abusive)
Comment 28 sophie 2014-04-15 13:53:47 UTC
*** Bug 77081 has been marked as a duplicate of this bug. ***
Comment 29 Justin L 2014-11-19 17:34:57 UTC
+1 for implementing this feature.  I'll probably get a lot of grief from those who don't want to migrate to LO because of this incompatibility with Word.

+1 for having someone point out where to do the coding.   I can think of 4 sections to identify.

1.)  The location of the frame vertical fitting code.  Hopefully a lot of the logic could simply be applied to a page.
2.)  The location of the code that draws/arranges the page.
3.)  The location of the code that imports the DOC content and handles (or ignores) the vertical orientation setting.
4.)  The styles UI code to add a vertical orientation setting.
Comment 30 Alex Thurgood 2015-01-03 17:38:37 UTC Comment hidden (no-value)
Comment 31 dave.computer 2015-02-15 04:35:40 UTC Comment hidden (no-value)
Comment 32 libre-bugs-2015 2015-03-04 06:44:40 UTC Comment hidden (me-too)
Comment 33 Jean-Baptiste Faure 2015-07-31 17:15:16 UTC Comment hidden (off-topic)
Comment 34 vermontpoet 2015-07-31 21:48:51 UTC Comment hidden (off-topic)
Comment 35 Jean-Baptiste Faure 2015-08-01 04:07:33 UTC
It is so important that there is not even test file attached to this bug report allowing to check how LibreOffice actually handle foreign documents with this configuration of the title page.
Please attach test documents.

Best regards. JBF
Comment 36 Justin L 2015-08-01 05:01:45 UTC
Created attachment 117570 [details]
document needing vertical centering in .doc and .pdf format
Comment 37 Justin L 2015-08-01 05:19:55 UTC
real life, non-title test document provided.  Setting status back to NEW.
Comment 38 Jean-Baptiste Faure 2015-08-01 11:43:43 UTC
(In reply to Justin L from comment #37)
> real life, non-title test document provided.  Setting status back to NEW.

Thank you for the test file. I see that there is a page break after each page. Is it an artifact of the docx import by LibreOffice or is it already the case when edited in MS-Word ?  Each page being independent, there is no text flow from a page to the next. So, if it is the original layout, it is a very strange use of a word processor, a presentation tool would be better to do that.

Best regards. JBF
Comment 39 Justin L 2015-08-01 12:10:30 UTC
(In reply to Jean-Baptiste Faure from comment #38 regarding attachment in Comment #36

The example document has never been touched by LibreOffice.  This is how the document was designed, for better or worse.  Publisher was not part of the purchased office suite, so only Word was available to make the document.  The main issue here IMHO is print compatibility of existing Word documents, and being able to pass documents between LO and MSO users - not whether there are other/better ways to accomplish the same thing in a re-created document.
Comment 40 Justin L 2015-08-01 12:18:49 UTC
(In reply to Jean-Baptiste Faure from comment #38)

Sorry, I didn't directly answer your question.  Yes, there is intentionally a page break on every page.  That is not a .doc import artifact.
Comment 41 vermontpoet 2015-08-01 12:59:01 UTC Comment hidden (abusive)
Comment 42 vermontpoet 2015-08-01 13:00:38 UTC
Created attachment 117575 [details]
A word document with a vertically centered period (.) . (word 97 doc file)

And as a doc file...
Comment 43 Justin L 2015-09-11 05:49:56 UTC
Created attachment 118596 [details]
zip containing various word2003-authored test scenario documents

When LO saves a file, the page's vertical adjustment setting is LOST.  Two patches are proposed to resolve that issue:
https://gerrit.libreoffice.org/18480 tdf#36117 .doc preserve page vertical alignment after RT
https://gerrit.libreoffice.org/18481 tdf#36117 .docx preserve page vertical alignment after RT

An additional task will be to allow LO to display the page according to this setting, and to allow basic editing of documents where the setting was already added.  A prototype implementation has been created.
https://gerrit.libreoffice.org/18482 prototype visual vertical page adjustment

A final task would be fully add support to .odt, and GUI options to create documents from scratch in LO.
Comment 44 Oliver Specht (CIB) 2015-10-05 09:44:13 UTC
*** Bug 93642 has been marked as a duplicate of this bug. ***
Comment 45 Commit Notification 2015-10-17 13:51:32 UTC
Justin Luth committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=fbd1c167851a04c60d91daa830cf93e5b2ad7b4d

tdf#36117 .doc preserve page vertical alignment after RT

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 46 vermontpoet 2015-10-17 14:00:59 UTC
So wait... What does this patch do? Does it only preserve the functionality of Word Documents? -- Or does it allow one to vertically center text in Libre too? What are we testing?
Comment 47 Justin L 2015-10-17 14:52:34 UTC
This ONLY preserves the setting.  That means that if you open and save in Writer, you won't lose the setting.  Currently if you "round-trip" it and open again in Word you have lost the vertical alignment setting.  The .doc patch fixes that (and shortly a patch for .docx should also land.)

In comment 43 I mentioned 3 parts for this fix.  The second part (vertical alignment visible in Writer's display) is proving very difficult to do.  I have a prototype that half-decently works, but is not even close to production ready and opens up a whole can of worms for anyone trying to edit the document.

So, there isn't much to test at this point, and don't get your hopes up for being able to VIEW this in Writer (without using a frame that is.  Writer/Word are both designed to support alignment inside a textframe).
Comment 48 Commit Notification 2015-10-19 04:37:01 UTC
Justin Luth committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=664197d95becd516c3dac25a50439078ba61e051

tdf#36117 .docx preserve page vertical alignment after RT

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 49 vermontpoet 2015-10-19 12:23:06 UTC Comment hidden (abusive)
Comment 50 Björn Michaelsen 2015-11-06 01:41:05 UTC
(In reply to vermontpoet from comment #49)
> This patch doesn't solve the initial bug report.

It doesnt claim so.

> *This* BUG, 36117, still stands.

Please dont add comments to bugs that do not contain new information. Beyond that, after 50 comment, please note: https://ask.libreoffice.org/en/question/59417/how-do-i-get-my-feature-implemented-in-libreoffice/

(And no, this is not the place to discuss _if_ this should be solved. This bug tracker is the place _only_ for collecting information needed to solve this issue. Comments not matching that criteria just make it harder for developers to find relevant information and thus lower the chances of this being implemented.)
Comment 51 Cor Nouws 2016-09-02 06:58:53 UTC
*** Bug 101845 has been marked as a duplicate of this bug. ***
Comment 52 Raymond Jennings 2016-09-02 13:57:42 UTC
Could I suggest that this bug/feature include "page setup" completely, and allow a page to be vertically aligned with top and bottom, as well as center?

A native option would:

1.  Allow import/export compatibility with MS Word
2.  Be super cool
3.  Allow flexibility in document layout

Finally, the apparent present method of using a table is counterintuitive.

Also, it probably requires you to micromanage the size of the table itself.  Something that directly anchors off of the page structure itself and could automatically align itself would be simpler.
Comment 53 Cor Nouws 2016-09-02 14:13:55 UTC
(In reply to Raymond Jennings from comment #52)
> Could I suggest that this bug/feature include "page setup" completely, and
> allow a page to be vertically aligned with top and bottom, as well as center?

Sure, that is the intention. Thanks for pointing out > Clarified the summary (feel free to improve yourself, if more is needed)